<template>
    <div v-if="data">
        <div class="form-group form-inline discount-group bordered-style-block">
            <div class="full-width">
                <div class="form-title">
                    <b>Logo</b>
                </div>
                <div><b>Logo image</b></div>
                <div class="dropzone-container">
                    <VueDropzone
                        id="dropzone"
                        ref="dropzone"
                        class="dz-clickable"
                        :options="dropzoneOptions"
                        :destroy-dropzone="false"
                        @vdropzone-removed-file="removeFile"
                        @vdropzone-mounted="setFile"
                        @vdropzone-success="updatePreview"
                        @vdropzone-file-added="checkChanged('logo')"
                    >
                        <div class="dz-default dz-message" />
                    </VueDropzone>
                </div>
                <div>
                    <div><b>Fallback Text</b></div>
                    <input
                        v-model="data.fallback_text"
                        type="text"
                        class="form-control full-width"
                        @blur="checkChanged('fallback_text')"
                    >
                </div>
            </div>
        </div>
        <div class="form-group discount-group bordered-style-block">
            <div class="full-width">
                <div class="form-title">
                    <b>Email Content</b>
                </div>
                <div><b>Logo image</b></div>
                <div class="row">
                    <div class="col-sm-4">
                        <div class="form-group">
                            <div class="title-color">
                                Header Text
                            </div>
                            <div class="jscolor-group">
                                <input
                                    id="title-color"
                                    v-model="data.colors.title"
                                    data-vv-as="Header Color"
                                    name="colors.title"
                                    type="text"
                                    class="my-input"
                                    @blur="checkChanged"
                                >
                                <button
                                    :style="{background: data.colors.title}"
                                    class="btn btn-color"
                                    type="button"
                                    @click="showPicker('title')"
                                />
                                <div
                                    v-if="pickerKeys.title"
                                    class="chrome-picker"
                                >
                                    <chrome
                                        :value="data.colors.title"
                                        @input="saveColor($event, 'title')"
                                    />
                                </div>
                            </div>
                        </div>
                    </div>
                    <div class="col-sm-4">
                        <div class="form-group">
                            <div class="title-color">
                                Body Text
                            </div>
                            <div class="jscolor-group">
                                <input
                                    id="body-color"
                                    v-model="data.colors.body_text"
                                    data-vv-as="Header Color"
                                    name="colors.body_text"
                                    type="text"
                                    class="my-input"
                                    @blur="checkChanged"
                                >
                                <button
                                    :style="{background: data.colors.body_text}"
                                    class="btn btn-color"
                                    type="button"
                                    @click="showPicker('body_text')"
                                />

                                <div
                                    v-show="pickerKeys.body_text"
                                    class="chrome-picker"
                                >
                                    <chrome
                                        :value="data.colors.body_text"
                                        @input="saveColor($event, 'body_text')"
                                    />
                                </div>
                            </div>
                        </div>
                    </div>
                    <div class="col-sm-4">
                        <div class="form-group">
                            <div class="title-color">
                                Links
                            </div>
                            <div class="jscolor-group">
                                <input
                                    id="link-color"
                                    v-model="data.colors.link"
                                    data-vv-as="Header Color"
                                    name="colors.link"
                                    type="text"
                                    class="my-input"
                                    @blur="checkChanged"
                                >
                                <button
                                    :style="{background: data.colors.link}"
                                    class="btn btn-color"
                                    type="button"
                                    @click="showPicker('link')"
                                />

                                <div
                                    v-show="pickerKeys.link"
                                    class="chrome-picker"
                                >
                                    <chrome
                                        :value="data.colors.link"
                                        @input="saveColor($event, 'link')"
                                    />
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
        <div class="form-group discount-group bordered-style-block">
            <div class="full-width">
                <div class="form-title">
                    <b>Call to action</b>
                </div>
                <div class="row">
                    <div class="col-sm-4">
                        <div class="form-group">
                            <div class="title-color">
                                Button Text
                            </div>
                            <div class="jscolor-group">
                                <input
                                    id="button-text-color"
                                    v-model="data.colors.button_text"
                                    data-vv-as="Header Color"
                                    name="colors.button_text"
                                    type="text"
                                    class="my-input"
                                    @blur="checkChanged"
                                >
                                <button
                                    :style="{background: data.colors.button_text}"
                                    class="btn btn-color"
                                    type="button"
                                    @click="showPicker('button_text')"
                                />

                                <div
                                    v-if="pickerKeys.button_text"
                                    class="chrome-picker"
                                >
                                    <chrome
                                        :value="data.colors.button_text"
                                        @input="saveColor($event, 'button_text')"
                                    />
                                </div>
                            </div>
                        </div>
                    </div>
                    <div class="col-sm-4">
                        <div class="form-group">
                            <div class="form-group">
                                <div class="title-color">
                                    Button Background
                                </div>
                                <div class="jscolor-group">
                                    <input
                                        id="button-color-color"
                                        v-model="data.colors.button_color"
                                        data-vv-as="Header Color"
                                        name="colors.button_color"
                                        type="text"
                                        class="my-input"
                                        @blur="checkChanged"
                                    >
                                    <button
                                        :style="{background: data.colors.button_color}"
                                        class="btn btn-color"
                                        type="button"
                                        @click="showPicker('button_color')"
                                    />

                                    <div
                                        v-show="pickerKeys.button_color"
                                        class="chrome-picker"
                                    >
                                        <chrome
                                            :value="data.colors.button_color"
                                            @input="saveColor($event, 'button_color')"
                                        />
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</template>

<script>
import VueDropzone from "vue2-dropzone";
import 'vue2-dropzone/dist/vue2Dropzone.min.css';
import {Chrome} from 'vue-color';
import headers from '../../../helpers/authHeader';
import link from '../../../helpers/backLink';

export default {
    name: "BrowseDesignEditor",
    components: {
        VueDropzone,
        Chrome
    },
    mixins:[headers, link],
    props: ['data', 'oldData', 'pickerKeys'],
    data() {
        return {
            dropzoneOptions: {
                url: this.getSegment()+'/email/viewed-products/' + this.$route.params.id + '/picture/',
                thumbnailWidth: 120,
                headers: {Authorization: `Bearer ${$cookies.get('userToken')}` },
                thumbnailHeight: 120,
                maxFiles: 1,
                maxFilesize: 0.512,
                addRemoveLinks: true,
                acceptedFiles: "image/jpeg,image/png",
                dictRemoveFile: 'Remove',
                dictDefaultMessage: '<div style="border: 1px dotted rgba(138, 135, 135, 0.36);\n' +
                    '    display: inline-block;\n' +
                    '    padding: 10px 20px 10px 40px;">' +
                    '<span class="mb-20">' +
                    '<img style="max-width:40px; margin-left: -20px;margin-right: 20px" src="/images/cart-icon-new.png">' +
                    '</span><b>Upload your logo image</b></div>'
            },

        }
    },
    methods: {
        saveColor(color, key) {
            this.data.colors[key] = color.hex
            this.checkChanged(`colors.${key}`)
        },
        checkChanged(key) {
            this.$emit('checkChanged', key)
        },
        showPicker(val) {
            this.hidePicker();
            document.addEventListener('click', this.documentClick);

            this.pickerKeys[val] = true;
        },
        documentClick(e) {
            if (e.target.className.indexOf('btn-color') === -1 && e.target.className.substr(0, 2) !== 'vc') {
                this.hidePicker()
            }
        },
        hidePicker() {
            document.removeEventListener('click', this.documentClick);
            for(const key in this.pickerKeys) {
                this.pickerKeys[key] = false;
            }
        },

        removeFile() {
            axios.delete(this.getSegment()+"/email/viewed-products/" + this.$route.params.id + '/picture', this.getUserHeader())
                .then(response => {
                    this.data.logo = null;
                    this.checkChanged('logo')
                });
        },
        setFile() {
            let file = {size: 0, name: "Icon", type: "image/jpeg"};
            let url = this.data.logo;

            if (url) {
                this.$refs.dropzone.manuallyAddFile(file, url);
            }
        },
        updatePreview(file, response) {
            this.data.logo = response
        },
    }
}
</script>

<style scoped lang="scss">

.my-input {
    max-width: 100px;
}

@media (min-width: 770px) {
    .form-inline .form-group {
        display: inline-block;
        margin-bottom: 0;
        vertical-align: middle;
    }
}

</style>
